// -*- C++ -*-
// generic socket DLL, winsock version
// disclaimer:  a C programmer wrote this.

// $Id: gensock.cpp 1.15 1994/11/23 22:38:10 rushing Exp $

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
	

extern "C" {
#include <winsock.h>
#include "intgensock.h"
#include "resource.h"
#include "wvglob.h"
}




//MDS increased buffer from 512 19991214
#define SOCKET_BUFFER_SIZE  1500
#define DESCR_SIZE 256

/* This is for NT */
HANDLE  dll_module_handle;
#define GET_CURRENT_TASK    dll_module_handle
#define TASK_HANDLE_TYPE    HANDLE
char    szDescription[DESCR_SIZE] = {0}; //description of SSL dll loaded


extern int WVTimedMessageBox(HWND hwnd, LPSTR lpText, LPSTR lpCaption,UINT uType);

int  init_winsock (void);
void deinit_winsock (void);

#ifdef _INCLSSL
#define SSLconnstr "SSL connection"

void DeInitSSL();
int InitSSL();

typedef int (*PFN_SSL_int_void)(void);
typedef PVOID (*PFN_SSL_pvoid_void)(void);
typedef PVOID (*PFN_SSL_pvoid_pvoid)(PVOID);
typedef void (*PFN_SSL_void_pvoid)(PVOID);
typedef int (*PFN_SSL_int_pvoid_int)(PVOID, int);
typedef int (*PFN_SSL_int_pvoid)(PVOID);
typedef int (*PFN_SSL_int_pvoid_pvoid_int)(PVOID, PVOID, int);
typedef int (*PFN_SSL_int_pvoid_pint)(PVOID, int*);
typedef char* (*PFN_SSL_pchar_pvoid)(PVOID);
typedef char* (*PFN_SSL_pchar_pvoid_pchar_int)(PVOID, char*, int);
typedef long (*PFN_SSL_long_pvoid_int_long_pvoid) (PVOID, int, long, PVOID);

PFN_SSL_int_void		SSL_library_init;		// int SSL_library_init()
PFN_SSL_pvoid_void		SSLv23_client_method;	// SSL_METHOD *SSLv23_client_method()
PFN_SSL_pvoid_void		TLSv1_client_method;	// SSL_METHOD *TLSv1_client_method()
PFN_SSL_pvoid_void		SSLv2_client_method;	// SSL_METHOD *SSLv2_client_method(void);
PFN_SSL_pvoid_pvoid		SSL_CTX_new;			// SSL_CTX *SSL_CTX_new(SSL_METHOD *method)
PFN_SSL_void_pvoid		SSL_CTX_free;			// void SSL_CTX_free(SSL_CTX *ctx);
PFN_SSL_pvoid_pvoid		SSL_new;				// SSL *SSL_new(SSL_CTX *ctx)
PFN_SSL_void_pvoid		SSL_free;				// void SSL_free(SSL *ssl);
PFN_SSL_int_pvoid_int	SSL_set_fd;				// int SSL_set_fd(SSL *ssl, int fd);
PFN_SSL_int_pvoid		SSL_connect;			// int SSL_connect(SSL *ssl);
PFN_SSL_int_pvoid_pvoid_int	SSL_read;			// int SSL_read(SSL *ssl, void *buffer, int bufsize)
PFN_SSL_int_pvoid_pvoid_int	SSL_write;			// int SSL_write(SSL *ssl, void *buffer, int bufsize)
PFN_SSL_int_pvoid_int	SSL_get_error;			// int SSL_write(SSL *ssl, int ret)
PFN_SSL_int_pvoid       SSL_pending;			// int SSL_pending(SSL *ssl);
PFN_SSL_int_pvoid		SSL_get_fd;				// int SSL_get_fd(const SSL *ssl);
PFN_SSL_pvoid_pvoid		SSL_get_current_cipher; // SSL_CIPHER *SSL_get_current_cipher(const SSL *ssl);
PFN_SSL_pchar_pvoid     SSL_CIPHER_get_name;	// const char *SSL_CIPHER_get_name(const SSL_CIPHER *cipher);
PFN_SSL_int_pvoid_pint	SSL_CIPHER_get_bits;	// int SSL_CIPHER_get_bits(const SSL_CIPHER *cipher, int *alg_bits);
PFN_SSL_pchar_pvoid		SSL_CIPHER_get_version;	// char *SSL_CIPHER_get_version(const SSL_CIPHER *cipher);
PFN_SSL_pchar_pvoid_pchar_int SSL_CIPHER_description; //char *SSL_CIPHER_description(SSL_CIPHER *cipher, char *buf, int size);
PFN_SSL_int_pvoid		SSL_do_handshake;		// int SSL_do_handshake(SSL *ssl);
PFN_SSL_int_pvoid		SSL_state;				// int SSL_state(SSL *ssl);
PFN_SSL_long_pvoid_int_long_pvoid  SSL_ctrl;	// long SSL_ctrl(SSL *s,int cmd,long larg,void *parg)



BOOL SSLLoaded=FALSE;
HINSTANCE hSSLLibrary=(HINSTANCE)NULL;
PVOID SSLCtx=NULL;
PVOID TLSCtx=NULL;
CRITICAL_SECTION sslHandleMutex;


#define SSL_ERROR_NONE			0
#define SSL_ERROR_SSL			1
#define SSL_ERROR_WANT_READ		2
#define SSL_ERROR_WANT_WRITE		3
#define SSL_ERROR_WANT_X509_LOOKUP	4
#define SSL_ERROR_SYSCALL		5 /* look at error stack/return value/errno */
#define SSL_ERROR_ZERO_RETURN		6
#define SSL_ERROR_WANT_CONNECT		7
#define SSL_ERROR_WANT_ACCEPT		8

#define SSL_get_cipher(s) \
                SSL_CIPHER_get_name(SSL_get_current_cipher(s))
#define SSL_get_cipher_name(s) \
                SSL_CIPHER_get_name(SSL_get_current_cipher(s))
#define SSL_get_cipher_bits(s,np) \
                SSL_CIPHER_get_bits(SSL_get_current_cipher(s),np)
#define SSL_get_cipher_version(s) \
                SSL_CIPHER_get_version(SSL_get_current_cipher(s))
#define SSL_get_cipher_description(s,cp,n) \
	SSL_CIPHER_description(SSL_get_current_cipher(s), cp, n)

#define SSL_MODE_AUTO_RETRY 0x00000004L
#define SSL_CTRL_MODE				33


#define SSL_set_mode(ssl,op) \
	SSL_ctrl((ssl),SSL_CTRL_MODE,(op),NULL)




#endif



//
//
//

#ifdef _DEBUG
	void complain (char * message)
	{
		OutputDebugString (message);
		MessageBox (NULL, message, "Winsock Error", MB_OK|MB_ICONHAND);

	}
	extern void TRACE(LPCTSTR szFormat, ...);

#else
	void complain (char * message)
	{
		//MessageBox (NetDoc.hWndFrame, message, "Winsock Error", MB_OK|MB_ICONHAND);
		//MessageBox (NULL, message, "Winsock Error", MB_OK|MB_ICONHAND);

		
		//need to test -MDS			
		char error_string[1024];
		strcpy(error_string, message);

		strcat(	error_string, "\r\nClose in 90 seconds...");
		WVTimedMessageBox(NULL, error_string, "Winsock Error" ,MB_OK|MB_ICONHAND);	
			

	}
	#define TRACE (void)0

#endif

//
// ---------------------------------------------------------------------------
// container for a buffered SOCK_STREAM.

class connection
{
private:
	SOCKET    the_socket;
	char *    in_buffer;
	char *    out_buffer;
	unsigned int  in_index;
	unsigned int  out_index;
	unsigned int  in_buffer_total;
	unsigned int  out_buffer_total;
	unsigned int  last_winsock_error;
	TASK_HANDLE_TYPE      owner_task;
	fd_set    fds;
	struct timeval    timeout;
	bool	bIsSSL;
	char *	szDescription; //description of connection protocol

#ifdef _INCLSSL

	//SSL*     ssl;
	//X509*    server_cert;
	//SSL_METHOD *meth;

	//PVOID SSLCtx;
	//PVOID TLSCtx;
	bool ConEstablished;
	PVOID hConnection;
	fd_set write_fds, read_fds;
	bool read_blocked;
	bool read_blocked_on_write;
	bool write_blocked_on_read;


#endif


public:

	connection (void);
	~connection (void);

	int       get_connected (char far * hostname, char far * service, eConnection UseSSL);
	SOCKET    get_socket(void) { return (the_socket); }
	TASK_HANDLE_TYPE      get_owner_task(void) { return (owner_task); }
	int       get_buffer(int wait);
	int       close (void);
	int       wvgetchar (int wait, char far * ch);
	int       put_data (char far * data, unsigned long length);
	int       put_data_buffered (char far* data, unsigned long length);
	int       put_data_flush (void);
	int		  get_description(char* desc, int length);
	int		  starttls();

};

connection::connection (void)
{
	the_socket = 0;
	in_index = 0;
	out_index = 0;
	in_buffer_total = 0;
	out_buffer_total = 0;
	in_buffer = 0;

	in_buffer = new char[SOCKET_BUFFER_SIZE];
	out_buffer = new char[SOCKET_BUFFER_SIZE+1];
	szDescription = NULL;
	last_winsock_error = 0;
	bIsSSL = false;
#ifdef _INCLSSL
	//SSLCtx = NULL;
	//TLSCtx = NULL;
	ConEstablished = false;
	hConnection = NULL;
	read_blocked = false;
	read_blocked_on_write = false; 
	write_blocked_on_read = false; 

#endif
}

connection::~connection (void)
{
	delete [] in_buffer;
	delete [] out_buffer;
	if (szDescription)
	{
		delete szDescription;
		szDescription = NULL;
	}
}

int	gensock_is_a_number (char far* string)
{
	while (*string) 
	{
		if (!isdigit (*string)) 
		{
			return (0);
		}
		string++;
	}
	return (1);
}

//
// ---------------------------------------------------------------------------
// UseSSL 0 = none, 1 = SSL, 2 = TLS

int	connection::get_connected (char FAR * hostname, char FAR * service, eConnection UseSSL)
{
	struct hostent FAR *  hostentry;
	struct servent FAR *  serventry;
	unsigned long     ip_address;
	struct sockaddr_in    sa_in;
	int           our_port;
	int           not = 0;
	int           retval = 0, err_code;
	unsigned long     ioctl_blocking = 1;
	char          message[512];


	// if the ctor couldn't get a buffer
	if (!in_buffer || !out_buffer)
		return (ERR_CANT_MALLOC);

#ifdef _INCLSSL
	if(!SSLLoaded && UseSSL != CONN_NORMAL)
		return ERR_SSL_NOTLOADED;
#endif

	// --------------------------------------------------
	// resolve the service name
	//

	// If they've specified a number, just use it.
	if (gensock_is_a_number (service)) 
	{
		char far* tail;
		our_port = (int) strtol (service, &tail, 10);
		if (tail == service) 
		{
			return (ERR_CANT_RESOLVE_SERVICE);
		} 
		else 
		{
			our_port = htons (our_port);
		}
	} 
	else 
	{
		// we have a name, we must resolve it.
		serventry = getservbyname (service, (LPSTR)"tcp");

		if (serventry)
			our_port = serventry->s_port;
		else 
		{
			retval = WSAGetLastError();
			// Chicago beta is throwing a WSANO_RECOVERY here...
			if ((retval == WSANO_DATA) || (retval == WSANO_RECOVERY)) 
			{
				return (ERR_CANT_RESOLVE_SERVICE);
			} 
			else 
			{
				return (retval - 5000);
			}
		}
	}

	// --------------------------------------------------
	// resolve the hostname/ipaddress
	//

	if ((ip_address = inet_addr (hostname)) != INADDR_NONE) 
	{
		sa_in.sin_addr.s_addr = ip_address;
	}
	else 
	{
		if ((hostentry = gethostbyname(hostname)) == NULL) 
		{
			return (ERR_CANT_RESOLVE_HOSTNAME);
		}
		sa_in.sin_addr.s_addr = *(long far *)hostentry->h_addr;
#if 0
	{
		OutputDebugString(inet_ntoa(sa_in.sin_addr));
	}
#endif
	}


	// --------------------------------------------------
	// get a socket
	//

	if ((the_socket = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) 
	{
		return (ERR_CANT_GET_SOCKET);
	}

	sa_in.sin_family = AF_INET;
	sa_in.sin_port = our_port;

	// set socket options.  DONTLINGER will give us a more graceful disconnect

	// MDS yes, and also terminate our connections before the last command
	// has been completely sent causing abnormal terminations on the receiving
	// side! 
	// From www.lcg.org/sock-faq
	// "... SO_LINGER seems to be required to guarantee delivery of all data."
	//20000410  
#if 0  
	setsockopt(the_socket,
	SOL_SOCKET,
	SO_DONTLINGER,
	(char *) &not, sizeof(not));
#endif
	// get a connection

	if ((retval = connect (the_socket, (struct sockaddr *)&sa_in,
							sizeof(struct sockaddr_in))==SOCKET_ERROR)) 
	{
		switch ((err_code = WSAGetLastError())) 
		{
			/* twiddle our thumbs until the connect succeeds */
			case WSAEWOULDBLOCK:
				break;
			case WSAECONNREFUSED:
				return (ERR_CONNECTION_REFUSED);
				break;
			default:
				wsprintf(message, "unexpected error %d from winsock\n", err_code);
				complain(message);
				return (ERR_CANT_CONNECT);
				break;
		}
	}

	owner_task = GET_CURRENT_TASK;

	if (!SSLLoaded || UseSSL != CONN_SSL)
	{
		// Make this a non-blocking socket
		ioctlsocket (the_socket, FIONBIO, &ioctl_blocking);


		// make the FD_SET and timeout structures for later operations...

		FD_ZERO (&fds);
		FD_SET  (the_socket, &fds);
			// normal timeout, can be changed by the wait option.
		timeout.tv_sec = 30;
		timeout.tv_usec = 0;
		return 0;



	}
	// normal timeout, can be changed by the wait option.
	timeout.tv_sec = 30;
	timeout.tv_usec = 0;
	retval = 0;

#ifdef _INCLSSL
#ifdef _DEBUG
		TRACE("<connect SSL>\n");
#endif


	bIsSSL = (UseSSL == CONN_SSL && SSLLoaded);


	if(NULL==(hConnection=SSL_new(SSLCtx)))
		retval = ERR_ESSL_CREATESSL;
	
	if(!retval)
		err_code = SSL_set_fd(hConnection,the_socket);
	if (err_code <1)
		retval = ERR_ESSL_SETSOCKET;

	if(!retval)
		  err_code = SSL_connect(hConnection); 	/* fails with SSL_ERROR_WANT_READ because of non-blocking */


	if (err_code < 1)
	{


		char what_error[256];
		 err_code = SSL_get_error(hConnection, err_code);
		wsprintf (what_error, "connection::connect() SSL_connect error: %d", err_code);
		complain (what_error);


		retval= ERR_ESSL_CONNECT;
	}
	else
	{
	  
	
	
//HANDLE hLib = LoadLibrary("libeay32.dll");
/*
	//functions in libeay32.dll
	X509_NAME *X509_get_subject_name(X509 *a);
	char * X509_NAME_oneline(X509_NAME *a, char *buf, int size);
	X509_get_subject_name(X509 *a);
	X509_get_issuer_name(X509 *a);
	X509_free(void *);
	CRYPTO_free(void *);
*/	  
	  
	  
	  
	  TRACE ("SSL connection using %s\n", SSL_get_cipher (hConnection));

	  int nbits = 0;
	  char desc[1024];

	  SSL_get_cipher_description(hConnection, desc, 1023); 
	  err_code = SSL_get_error(hConnection, 0);

	  szDescription = new char[	strlen(desc) +1];
	  if ( szDescription)
	  {
		strcpy(szDescription, desc);
	  }

	  desc[1023]=0;

	  TRACE("SSL connection:%s\r\n", desc);
  
#if 0
	  /* Get server's certificate (note: beware of dynamic allocation) - opt */

	  X509* server_cert = SSL_get_peer_certificate (ssl);       
	  
	  printf ("Server certificate:\n");
  
	  str = X509_NAME_oneline (X509_get_subject_name (server_cert),0,0);
	 
	  printf ("\t subject: %s\n", str);
	  CRYPTO_free (str);

	  str = X509_NAME_oneline (X509_get_issuer_name  (server_cert),0,0);
	  CHK_NULL(str);
	  printf ("\t issuer: %s\n", str);
	  CRYPTO_free (str);

	  /* We could do all sorts of certificate verification stuff here before
		 deallocating the certificate. */

	  X509_free (server_cert);
#endif
	}
	
	if (!retval)
	{
		ConEstablished=TRUE;
	//	ioctlsocket (the_socket, FIONBIO, &ioctl_blocking);
	// make the FD_SET and timeout structures for later operations...

	FD_ZERO (&read_fds);
	FD_ZERO (&write_fds);
	FD_SET( (SOCKET) SSL_get_fd(hConnection) ,&read_fds);
	FD_SET((SOCKET) SSL_get_fd(hConnection) ,&write_fds);



#if _DEBUG
	TRACE("%s to %s:%d %s.",SSLconnstr,hostname,service,"established");
#endif
	}
	else
	{
		ConEstablished = FALSE;
		bIsSSL = FALSE;
	}

#endif

return (retval);
}

int	connection::starttls()
{
	int retval = ERR_CANT_CONNECT, err_code = 0;

#ifdef _INCLSSL


	if (!SSLLoaded)
		return ERR_SSL_NOTLOADED;


	// normal timeout, can be changed by the wait option.
	timeout.tv_sec = 30;
	timeout.tv_usec = 0;
	retval = 0;

	TRACE("<connect SSL TLS>\n");



	bIsSSL =  true;


	if(NULL==(hConnection=SSL_new(SSLCtx)))
		retval = ERR_ESSL_CREATESSL;
	
	if(!retval)
		err_code = SSL_set_fd(hConnection,the_socket);
	if (err_code <1)
		retval = ERR_ESSL_SETSOCKET;

	SSL_set_mode(hConnection, SSL_MODE_AUTO_RETRY);

	if(!retval)
		  err_code = SSL_connect(hConnection);

	/* Initiates the TLS handshake with a server */
	while((retval= SSL_connect(hConnection)) <= 0)
	{
		int err = SSL_get_error(hConnection, retval);

		FD_ZERO (&read_fds);
		FD_ZERO (&write_fds);
		
		

		if(err == SSL_ERROR_WANT_READ)
			FD_SET( (SOCKET) SSL_get_fd(hConnection) ,&read_fds);
		else if(err == SSL_ERROR_WANT_WRITE)
			FD_SET((SOCKET) SSL_get_fd(hConnection) ,&write_fds);
		else
		{
			TRACE("SSL connect failed %d",retval);
			ConEstablished = FALSE;
			bIsSSL = FALSE;

			return -1;
		}
		retval=select(SSL_get_fd(hConnection) + 1, &read_fds, &write_fds, NULL, &timeout);
	}
	{

		ConEstablished = TRUE;
		bIsSSL = TRUE;
		retval = 0;
	  
	  
	  TRACE ("SSL connection using %s\n", SSL_get_cipher (hConnection));

	  char desc[1024];

	  SSL_get_cipher_description(hConnection, desc, 1023); 
	  err_code = SSL_get_error(hConnection, 0);

	  szDescription = new char[	strlen(desc) +1];
	  if ( szDescription)
	  {
			strcpy(szDescription, desc);
	  }
  

	}
	
#endif
return (retval);

	
}


int connection::get_description(char* desc, int length)
{
#ifdef _INCLSSL
	if (!desc || length <=0)
		return ERR_CANT_MALLOC;

	if (szDescription)
		strncpy(desc, szDescription, length);
	else 
		*desc = '\0'; 
#endif
return 0;

}


//
//---------------------------------------------------------------------------
//
// The 'wait' parameter, if set, says to return WAIT_A_BIT
// if there's no data waiting to be read.

int	connection::get_buffer(int wait)
{
	int retval =0;
	int bytes_read = 0;
	unsigned long ready_to_read = 0;
	int error =0;

	// Use select to see if data is waiting...

#ifdef _INCLSSL
	while (bIsSSL)
	{

		FD_ZERO (&read_fds);
		FD_SET(SSL_get_fd(hConnection),&read_fds);
		// if wait is set, we are polling, return immediately
		if (wait) 
		{
			timeout.tv_sec = 0;
		}
		else 
		{
			timeout.tv_sec = 30;
		}


		retval=select(0,&read_fds,NULL,NULL,&timeout);


		// if we don't want to wait
		/*if (!retval  ) 
		{
			if (wait)
				return (WAIT_A_BIT);
		}
		*/

		if (!FD_ISSET(SSL_get_fd(hConnection),&read_fds))
		{
			
			retval = SSL_pending(hConnection);
			if (!retval)
			{
				if (wait)
					return (WAIT_A_BIT);
				continue;
			}

		}

	
		//
		//if (!retval && wait)
		//	return (WAIT_A_BIT);
		// Request ownership of the critical section.
		__try 
		{
			EnterCriticalSection(&sslHandleMutex); 

			// Access the shared resource.
			ZeroMemory(in_buffer,SOCKET_BUFFER_SIZE);
			bytes_read = SSL_read(hConnection, in_buffer, SOCKET_BUFFER_SIZE);
			error = SSL_get_error(hConnection,bytes_read);

		}
		__finally 
		{
			// Release ownership of the critical section.
			LeaveCriticalSection(&sslHandleMutex);
		}


		

		switch(	error)
		{
			case SSL_ERROR_NONE:
				/* Note: this call could block, which blocks the
				entire application. It's arguable this is the
				right behavior since this is essentially a terminal
				client. However, in some other applications you
				would have to prevent this condition */
				in_buffer_total	= bytes_read;
				in_index = 0;

				break;
			case SSL_ERROR_ZERO_RETURN:
				TRACE("SSL_ERROR_ZERO_RETURN\r\n");
			//connection gone
				return (ERR_NOT_CONNECTED);
				break;
			case SSL_ERROR_WANT_READ:
				TRACE("SSL_ERROR_WANT_READ\r\n");

				read_blocked=true;
				break;

			/* We get a WANT_WRITE if we're
			trying to rehandshake and we block on
			a write during that rehandshake.

			We need to wait on the socket to be 
			writeable but reinitiate the read
			when it is */
			case SSL_ERROR_WANT_WRITE:
				TRACE("SSL_ERROR_WANT_WRITE\r\n");
				read_blocked_on_write=1;
				break;
			default:
			{
				char what_error[256];

				TRACE("SSL read problem %d\r\n", error);
				wsprintf (what_error, "connection::get_buffer() SSL_read unexpected error: %d", error);
				complain (what_error);
				return (ERR_READING_SOCKET);
			}

		}

		if(bytes_read < 1)
		{
			char what_error[256];

			
			wsprintf (what_error, "connection::get_buffer() SSL_read unexpected error: %d", error);
			complain (what_error);
		}
		else
		{
			in_buffer_total	= bytes_read;
			in_index = 0;
		}
#ifdef _DEBUG
		*(in_buffer+bytes_read)=0;				//end the buffer to write it to file
		TRACE("SSL recv %s",in_buffer);

#endif
		return (0);
	}

#endif

	//non SSL


	FD_ZERO (&fds);
	FD_SET  (the_socket, &fds);


	// if wait is set, we are polling, return immediately
	if (wait) 
	{
		timeout.tv_sec = 0;
	}
	else 
	{
		timeout.tv_sec = 30;
	}



	if ((retval = select (0, &fds, NULL, NULL, &timeout)) == SOCKET_ERROR) 
	{
		char what_error[256];
		int error_code = WSAGetLastError();

		if (error_code == WSAEINPROGRESS && wait) 
		{
			return (WAIT_A_BIT);
		}

		wsprintf (what_error, "connection::get_buffer() unexpected error from select: %d", error_code);
		complain (what_error);
	}


	// if we don't want to wait
	if (!retval && wait) 
	{
		return (WAIT_A_BIT);
	}



	// we have data waiting...
	bytes_read = recv (the_socket, in_buffer, SOCKET_BUFFER_SIZE, 0);

	// just in case.
	if (bytes_read == 0) 
	{
		// connection terminated (semi-) gracefully by the other side
		return (ERR_NOT_CONNECTED);
	}

	if (bytes_read == SOCKET_ERROR) 
	{
		char what_error[256];
		int ws_error = WSAGetLastError();
		switch (ws_error) {
			// all these indicate loss of connection (are there more?)
			case WSAENOTCONN:
			case WSAENETDOWN:
			case WSAENETUNREACH:
			case WSAENETRESET:
			case WSAECONNABORTED:
			case WSAECONNRESET:
				return (ERR_NOT_CONNECTED);
				break;

			case WSAEWOULDBLOCK:
				return (WAIT_A_BIT);
				break;

			default:
				wsprintf (what_error, "connection::get_buffer() unexpected error: %d", ws_error);
				complain (what_error);
		}
	}

	// reset buffer indices.
	in_buffer_total = bytes_read;
	in_index = 0;
	return (0);

}

//
//---------------------------------------------------------------------------
// get a character from this connection.
//

int connection::wvgetchar(int wait, char FAR * ch)
{
	int retval;

	if (in_index >= in_buffer_total) 
	{
		if ((retval = get_buffer(wait)))
			return (retval);
	}
	*ch = in_buffer[in_index++];
	return (0);
}


//
//---------------------------------------------------------------------------
// FIXME: should try to handle the fact that send can only take
// an int, not an unsigned long.

int connection::put_data (char far* data, unsigned long length)
{
	int num_sent;
	int retval;	
	int error = 0;

	FD_ZERO (&fds);
	FD_SET  (the_socket, &fds);

	timeout.tv_sec = 30;

	while (length > 0) 
	{

#ifdef _INCLSSL
		if (bIsSSL)
		{
		// Request ownership of the critical section.
		__try 
		{
			EnterCriticalSection(&sslHandleMutex); 

			// Access the shared resource.
			num_sent = SSL_write(hConnection,(PVOID)data, length);
			error = SSL_get_error(hConnection,num_sent);


		}
		__finally 
		{
			// Release ownership of the critical section.
			LeaveCriticalSection(&sslHandleMutex);
		}



			switch (error)
			{
				case SSL_ERROR_NONE:
					break;
				
				/* We get a WANT_READ if we're
				   trying to rehandshake and we block on
				   write during the current connection.
               
				   We need to wait on the socket to be readable
				   but reinitiate our write when it is */

				case SSL_ERROR_WANT_READ:
					TRACE("SSL_ERROR_WANT_READ\r\n");
					write_blocked_on_read=1;
					break;
					
					//we would have blocked
				case SSL_ERROR_WANT_WRITE:
					TRACE("SSL_ERROR_WANT_WRITE\r\n");
					break;
				
				default:
				TRACE("SSL_Write unknown response %d\r\n", error);
					break;
			}

			if(num_sent < 0)
			{
				char what_error[256];

				wsprintf (what_error, "connection::put_data() unexpected error from send(): %d",error);
				complain (what_error);

				return 0;


			}
			else if (num_sent != length)
			{
				
				if (num_sent == 0)
					return (ERR_NOT_CONNECTED);
				
				length -= num_sent;
				data += num_sent;

				continue;

			}
			else
				return 0;
		}
#endif 
		
		if ((retval = select (0, NULL, &fds, NULL, &timeout)) == SOCKET_ERROR) 
		{
			char what_error[256];
			int error_code = WSAGetLastError();

			wsprintf (what_error,"connection::put_data() unexpected error from select: %d",error_code);
			complain (what_error);
		}

		num_sent = send (the_socket, data, length > 1024 ? 1024 : (int)length, 0);

		if (num_sent == SOCKET_ERROR) 
		{
			char what_error[256];
			int ws_error = WSAGetLastError();
			switch (ws_error) 
			{
				// this is the only error we really expect to see.
				case WSAENOTCONN:
					return (ERR_NOT_CONNECTED);
					break;

				// seems that we can still get a block
				case WSAEWOULDBLOCK:
				case WSAEINPROGRESS:
					break;

				default:
					wsprintf (what_error, "connection::put_data() unexpected error from send(): %d",ws_error);
					complain (what_error);
					return (ERR_SENDING_DATA);
			}
		}
		else 
		{
			length -= num_sent;
			data += num_sent;
		}
	}

	return (0);
}

//
//
// buffered output
//

int	connection::put_data_buffered (char far* data, unsigned long length)
{
	unsigned int sorta_sent = 0;
	int retval;

	while (length) 
	{
		if ((out_index + length) < SOCKET_BUFFER_SIZE) 
		{
			// we won't overflow, simply copy into the buffer
			memcpy (out_buffer + out_index, data, (size_t) length);
			out_index += (unsigned int) length;
			length = 0;
		}
		else 
		{
			unsigned int orphaned_chunk = SOCKET_BUFFER_SIZE - out_index;
			// we will overflow, handle it
			memcpy (out_buffer + out_index, data, orphaned_chunk);
			// send this buffer...
			
			if ((retval = put_data (out_buffer, SOCKET_BUFFER_SIZE))) 
			{
				return (retval);
			}
			length -= orphaned_chunk;
			out_index = 0;
			data += orphaned_chunk;
		}
	}

	return (0);
}

int	connection::put_data_flush (void)
{
	int retval;
	*(out_buffer + out_index ) = 0;
	if ((retval = put_data (out_buffer, out_index)))
		return (retval);
	else
		out_index = 0;

	return(0);
}

//
//---------------------------------------------------------------------------
//

int	connection::close (void)
{
	int retval = closesocket(the_socket);
	the_socket=INVALID_SOCKET;

#ifdef _INCLSSL

	if(hConnection != (HANDLE)NULL)
		SSL_free(hConnection);
	
	hConnection=(HANDLE)NULL;
#ifdef _DEBUG
	if (ConEstablished) 
		TRACE("%s %s.",SSLconnstr,"closed");
#endif
	
	ConEstablished=FALSE;
#endif

	if (retval == SOCKET_ERROR)
		return (ERR_CLOSING);
	else
		return (0);
}


//
//---------------------------------------------------------------------------
// we keep lists of connections in this class

class connection_list
{
private:
	connection *      data;
	connection_list *     next;

public:
	connection_list   (void);
	~connection_list  (void);
	void push         (connection & conn);

	// should really use pointer-to-memberfun for these
	connection * find (SOCKET sock);
	int how_many_are_mine (void);

	void remove       (socktag sock);
};

connection_list::connection_list (void)
{
	next = 0;
}

connection_list::~connection_list(void)
{
	delete data;
}

// add a new connection to the list

void connection_list::push (connection & conn)
{
	connection_list * new_conn;

	new_conn = new connection_list();

	new_conn->data = data;
	new_conn->next = next;

	data = &conn;
	next = new_conn;

}

int connection_list::how_many_are_mine(void)
{
	TASK_HANDLE_TYPE  current_task = GET_CURRENT_TASK;
	connection_list * iter = this;
	int num = 0;

	while (iter->data) 
	{
		if (iter->data->get_owner_task() == current_task)
			num++;
		iter = iter->next;
	}
	return (num);
}

// find a particular socket's connection object.

connection * connection_list::find (SOCKET sock)
{
	connection_list * iter = this;

	while (iter->data) 
	{
		if (iter->data->get_socket() == sock)
			return (iter->data);
		iter = iter->next;
	}

	return (0);
}

void connection_list::remove (socktag sock)
{
	// at the end
	if (!data)
		return;

	// we can assume next is valid because
	// the last node is always {0,0}
	if (data == sock) 
	{
		delete data;
		data = next->data;
		next = next->next;  // 8^)
		return;
	}

	// recurse
	next->remove(sock);
}

//
// ---------------------------------------------------------------------------
// global variables (shared by all DLL users)

connection_list global_socket_list;
int network_initialized;



// ---------------------------------------------------------------------------
// C/DLL interface
//

int FAR PASCAL  gensock_connect (char FAR * hostname, char FAR * service, socktag FAR * pst, char UseSSL)
{
	int retval;
	connection * conn = new connection;

	if (!conn)
		return (ERR_INITIALIZING);

	// if this task hasn't opened any sockets yet, then
	// call WSAStartup()

	if (global_socket_list.how_many_are_mine() < 1)
		init_winsock();

	global_socket_list.push(*conn);

	if ((retval = conn->get_connected (hostname, service, (eConnection) UseSSL))) 
	{
		gensock_close(conn);
		*pst = 0;
		return (retval);
	}
	*pst = (void FAR *) conn;

	return (0);
}

int FAR PASCAL  gensock_starttls (socktag st)
{

	connection * conn;
	int retval = 0;

	conn = (connection *) st;
	if (!conn)
		return (ERR_NOT_A_SOCKET);

	if ((retval = conn->starttls()))
		return (retval);
	else
		return (0);


}

int FAR PASCAL gensock_description (socktag st, char* desc, int nLen)
{

#ifdef _INCLSSL

	connection * conn;
	int retval = 0;
	
	if (global_socket_list.how_many_are_mine() < 1)
		init_winsock();
	
	conn = (connection *) st;
	if (!conn)
	{
		
		strncpy(desc, szDescription, nLen);
		return (0);
	}

	if ((retval = conn->get_description(desc, nLen)))
		return (retval);
	else
#endif
		return (0);


}


//
//
//

int FAR PASCAL  gensock_getchar (socktag st, int wait, char FAR * ch)
{
	connection * conn;
	int retval = 0;

	conn = (connection *) st;
	if (!conn)
		return (ERR_NOT_A_SOCKET);

	if ((retval = conn->wvgetchar(wait, ch)))
		return (retval);
	else
		return (0);
}


//---------------------------------------------------------------------------
//
//

int FAR PASCAL  gensock_put_data (socktag st, char FAR * data, unsigned long length)
{
	connection * conn;
	int retval = 0;

	conn = (connection *) st;

	if (!conn)
		return (ERR_NOT_A_SOCKET);

	if ((retval = conn->put_data(data, length)))
		return (retval);

	return (0);
}

//---------------------------------------------------------------------------
//
//

int FAR PASCAL  gensock_put_data_buffered (socktag st, char FAR * data, unsigned long length)
{
	connection * conn;
	int retval = 0;

	conn = (connection *) st;

	if (!conn)
		return (ERR_NOT_A_SOCKET);

	if ((retval = conn->put_data_buffered (data, length)))
		return (retval);

	return (0);
}

//---------------------------------------------------------------------------
//
//

int FAR PASCAL  gensock_put_data_flush (socktag st)
{
	connection * conn;
	int retval = 0;

	conn = (connection *) st;

	if (!conn)
		return (ERR_NOT_A_SOCKET);

	if ((retval = conn->put_data_flush() ))
		return (retval);

	return (0);
}

//---------------------------------------------------------------------------
//
//
int FAR PASCAL  gensock_gethostname (char FAR * name, int namelen)
{
	int retval;
	if ((retval = gethostname(name, namelen))) 
	{
		return (retval - 5000);
	}
	else return (0);
}

/*
int FAR PASCAL  gensock_myhostname (char FAR * name, int namelen, socktag FAR * pst)
{

	connection * pconn = (connection*) *pst;

	int retval;
	if ((retval = gethostname(name, namelen))) 
	{
		return (retval - 5000);
	}
	else return (0);

	//Try using socket name instead
	int sock, sent, addrlen = sizeof(struct sockaddr_in);
	struct sockaddr_in someAddr;
    
	StatusAdd( this, IDS_WINSOCK_SOCKETNAME, IDC_EB_LRESULTS); //socket address lookup


	memset(&someAddr, 0, sizeof(someAddr));
	someAddr.sin_family = AF_INET;
	someAddr.sin_port = htons(9); // 9 is discard
	someAddr.sin_addr.s_addr = inet_addr("141.142.103.20");
	 // something at NCSA, it doesn't matter much though
    
	if( ((sock = socket(AF_INET, SOCK_DGRAM, 0)) != INVALID_SOCKET) 
		&& (connect( sock, (struct sockaddr*)&someAddr, sizeof(someAddr) ) != SOCKET_ERROR) 
		&& (getsockname(sock, (struct sockaddr*)&myAddr, &addrlen) != SOCKET_ERROR) 
		&& (myAddr.sin_addr.s_addr != htonl(INADDR_ANY)) 
		&& (myAddr.sin_addr.s_addr != htonl(INADDR_LOOPBACK)) )
	{ 
		//getsockname worked
		nHostMode = USESOCKETNAME;
		TRACE("socket(SOCK_DRAM)/connect()/getsockname() worked\n");
	}
	else if( ((sent = send(sock, (char*)&sock, sizeof(sock), 0)) != SOCKET_ERROR) 
		&& (sent > 0) && (addrlen = sizeof(struct sockaddr_in)) 
		&& (getsockname(sock, (struct sockaddr*)&myAddr, &addrlen) != SOCKET_ERROR)
		&& (myAddr.sin_addr.s_addr != htonl(INADDR_ANY)) 
		&& (myAddr.sin_addr.s_addr != htonl(INADDR_LOOPBACK)) ) 
	{
		//getsockname after send worked
		nHostMode = USESOCKETNAME;
		TRACE("socket(SOCK_DRAM)/connect()/send()/getsockname() worked\n");
	} 
	else 
	{
		//nothing worked
		StatusAppend( this, IDS_FAILED, IDC_EB_LRESULTS); //Failed
		TRACE("nothing worked\n");
	}

  
	//Found IP Address via socket name, print out the stats
	if (nHostMode == USESOCKETNAME)
	{
		StatusAppend( this, IDS_OK, IDC_EB_LRESULTS); //OK

		//Print TCP/IP address
		StatusAdd( this, IDS_WINSOCK_ADDR, IDC_EB_LRESULTS);
		csTemp = inet_ntoa( myAddr.sin_addr );
		StatusAppend( this, csTemp, IDC_EB_LRESULTS)
	}

}
*/
//---------------------------------------------------------------------------
//
//

int FAR PASCAL  gensock_close (socktag st)
{
	connection * conn;
	int retval;

	conn = (connection *) st;

	if (!conn)
		return (ERR_NOT_A_SOCKET);

	retval = conn->close();
	
	global_socket_list.remove((connection *)st);


	if (global_socket_list.how_many_are_mine() < 1) 
	{
		deinit_winsock();
#ifdef _INCSSL		
		DeInitSSL();
#endif
	}

	return (retval);
}

//---------------------------------------------------------------------------
//
//

int	init_winsock(void)
{
	int retval;
	WSADATA winsock_data;
	WORD version_required = 0x0101; /* Version 1.1 */
#ifdef _INCLSSL
	version_required =MAKEWORD(2,0);
#endif

	retval = WSAStartup (version_required, &winsock_data);

	switch (retval) 
	{
		case 0:
		/* successful */
			break;
		case WSASYSNOTREADY:
			return (ERR_SYS_NOT_READY);
			break;
		case WSAEINVAL:
			return (ERR_EINVAL);
			break;
		case WSAVERNOTSUPPORTED:
			return (ERR_VER_NOT_SUPPORTED);
			break;
	}
	network_initialized = 1;
#ifdef _INCLSSL
	if (!retval && !SSLLoaded)
		retval = InitSSL();
#endif

	return (0);
}

void deinit_winsock(void)
{
	network_initialized = 0;
#ifdef _INCLSSL
	DeInitSSL();
#endif
	WSACleanup();
}

#ifdef _INCLSSL

DWORD GetSSLVersion(LPTSTR lpszFilename)
{
    DWORD   dwVersion = 0; 
    DWORD   dwSize;         // Size of mem needed to hold version info
    DWORD   dwDummy;        // Pointer to variable to receive zero
    TCHAR   SubBlock[256];
    // Get Version info size  
    dwSize = GetFileVersionInfoSize(lpszFilename, &dwDummy);
    if (dwSize != 0)
    {
        // Allocate space to hold the info
        LPBYTE pInfoBuf = (LPBYTE) GlobalAllocPtr (GHND, dwSize);
        if (pInfoBuf != NULL)
        {
            // Get the info 
            if (GetFileVersionInfo(lpszFilename, 0, dwSize, pInfoBuf))
            {
                // Got version info, get pointer to VS_FIXEDFILEINFO & size
                // (non language dependant part)
                VS_FIXEDFILEINFO FAR *lpBuffer;     // Pointer to version results 
                unsigned int nBuffSize;             // Size of version results

                VerQueryValue(pInfoBuf, _T("\\"), (void far**)&lpBuffer, &nBuffSize);
                if (nBuffSize != 0)
                {
                    // File version stored as 64bit word (4 16 bit values)
                    // Convert this to 32bit word (4 8 bit values)
                    dwVersion =
                     ( (DWORD)(LOBYTE(HIWORD(lpBuffer->dwFileVersionMS))) << 24 
                    |  (DWORD)(LOBYTE(LOWORD(lpBuffer->dwFileVersionMS))) << 16
                    |  (DWORD)(LOBYTE(HIWORD(lpBuffer->dwFileVersionLS))) << 8
                    |  (DWORD)(LOBYTE(LOWORD(lpBuffer->dwFileVersionLS))) );
                } // if we got VS_FIXEDFILEINFO data


				// Structure used to store enumerated languages and code pages.

				struct LANGANDCODEPAGE 
				{
					WORD wLanguage;
					WORD wCodePage;
				} *lpTranslate;
				UINT  cbTranslate = 0;

				// Read the list of languages and code pages.

				VerQueryValue(pInfoBuf, 
								TEXT("\\VarFileInfo\\Translation"),
								(LPVOID*)&lpTranslate,
								&cbTranslate);

				// Read the file description for each language and code page.

				for( int i=0; i < (cbTranslate/sizeof(struct LANGANDCODEPAGE)); i++ )
				{
					wsprintf( SubBlock, 
								TEXT("\\StringFileInfo\\%04x%04x\\FileDescription"),
								lpTranslate[i].wLanguage,
								lpTranslate[i].wCodePage);
								char *pbuf;
							
								// Retrieve file description for language and code page "i". 
								VerQueryValue(pInfoBuf, 
								SubBlock, 
								(LPVOID*)&pbuf, 
								&nBuffSize);

					if (!*szDescription || lpTranslate[i].wLanguage == GetSystemDefaultLangID())
					{
						strncpy(szDescription, pbuf, min(nBuffSize, DESCR_SIZE)); 
						szDescription[min(nBuffSize, DESCR_SIZE)-1] = 0;
						
						if (strlen(szDescription) + 24 < DESCR_SIZE)
						
						wsprintf(szDescription + strlen(szDescription),"- %d.%d.%d.%d", 
							(int)(LOBYTE(HIWORD(lpBuffer->dwFileVersionMS))),
							(int)(LOBYTE(LOWORD(lpBuffer->dwFileVersionMS))),
							(int)(LOBYTE(HIWORD(lpBuffer->dwFileVersionLS))),
							(int)(LOBYTE(LOWORD(lpBuffer->dwFileVersionLS))) ); 

					}


					if (lpTranslate[i].wLanguage == GetSystemDefaultLangID())
					{
						break;
					}
				}
				

            } // If we found version info

            // Let go of the memory
            GlobalFreePtr(pInfoBuf);

        } // If we allocated memory
    } // If file has version info
    
    return dwVersion;
} 
int InitSSL()
{

	if (hSSLLibrary)
	{
		return ERR_ESSL_ALREADYLOADED;
	}

	{	
		TCHAR path[_MAX_PATH], *p;
				
		DWORD dwVer = 0;
		if (SearchPath(NULL,"ssleay32.dll", NULL, _MAX_PATH, path, &p))
		{
			GetSSLVersion(path);	
			hSSLLibrary = LoadLibrary(path);
		}
	}
	
	if (!hSSLLibrary)
		return ERR_SSL_NOTLOADED;



	if(NULL!=(SSL_library_init=(PFN_SSL_int_void)GetProcAddress(hSSLLibrary,"SSL_library_init")))
	if(NULL!=(SSLv23_client_method=(PFN_SSL_pvoid_void)GetProcAddress(hSSLLibrary,"SSLv23_client_method")))
	if(NULL!=(SSL_CTX_new=(PFN_SSL_pvoid_pvoid)GetProcAddress(hSSLLibrary,"SSL_CTX_new")))
	if(NULL!=(SSL_CTX_free=(PFN_SSL_void_pvoid)GetProcAddress(hSSLLibrary,"SSL_CTX_free")))
	if(NULL!=(SSL_new=(PFN_SSL_pvoid_pvoid)GetProcAddress(hSSLLibrary,"SSL_new")))
	if(NULL!=(SSL_free=(PFN_SSL_void_pvoid)GetProcAddress(hSSLLibrary,"SSL_free")))
	if(NULL!=(SSL_set_fd=(PFN_SSL_int_pvoid_int)GetProcAddress(hSSLLibrary,"SSL_set_fd")))
	if(NULL!=(SSL_get_fd=(PFN_SSL_int_pvoid)GetProcAddress(hSSLLibrary,"SSL_get_fd")))
	if(NULL!=(SSL_connect=(PFN_SSL_int_pvoid)GetProcAddress(hSSLLibrary,"SSL_connect")))
	if(NULL!=(SSL_pending=(PFN_SSL_int_pvoid)GetProcAddress(hSSLLibrary,"SSL_pending")))
	if(NULL!=(SSL_read=(PFN_SSL_int_pvoid_pvoid_int)GetProcAddress(hSSLLibrary,"SSL_read")))
	if(NULL!=(SSL_write=(PFN_SSL_int_pvoid_pvoid_int)GetProcAddress(hSSLLibrary,"SSL_write")))
	if(NULL!=(SSL_do_handshake=(PFN_SSL_int_pvoid)GetProcAddress(hSSLLibrary,"SSL_do_handshake")))
	if(NULL!=(SSL_state=(PFN_SSL_int_pvoid)GetProcAddress(hSSLLibrary,"SSL_state")))
	if(NULL!=(SSL_ctrl=(PFN_SSL_long_pvoid_int_long_pvoid)GetProcAddress(hSSLLibrary,"SSL_ctrl")))
	//used to determine encryption
	if(NULL!=(SSL_CIPHER_get_name=(PFN_SSL_pchar_pvoid)GetProcAddress(hSSLLibrary,"SSL_CIPHER_get_name")))
	if(NULL!=(SSL_get_current_cipher=(PFN_SSL_pvoid_pvoid)GetProcAddress(hSSLLibrary,"SSL_get_current_cipher")))
	if(NULL!=(SSL_CIPHER_get_bits=(PFN_SSL_int_pvoid_pint)GetProcAddress(hSSLLibrary,"SSL_CIPHER_get_bits")))
	if(NULL!=(SSL_CIPHER_get_version=(PFN_SSL_pchar_pvoid)GetProcAddress(hSSLLibrary,"SSL_CIPHER_get_version")))
	if(NULL!=(SSL_CIPHER_description=(PFN_SSL_pchar_pvoid_pchar_int)GetProcAddress(hSSLLibrary,"SSL_CIPHER_description")))

	if(NULL!=(SSL_get_error=(PFN_SSL_int_pvoid_int)GetProcAddress(hSSLLibrary,"SSL_get_error")))
	{
		TLSv1_client_method=(PFN_SSL_pvoid_void)GetProcAddress(hSSLLibrary,"TLSv1_client_method");
		if (TLSv1_client_method) 
		{
			TLSCtx=SSL_CTX_new(TLSv1_client_method());	//TLS1 only used 
		} 
		else 
		{
			TRACE("TLSv1 not available");
		}
		SSL_library_init();
		SSLCtx=SSL_CTX_new(SSLv23_client_method());	//SSL2,3 & TLS1 used

		SSLLoaded=TRUE;
		TRACE("SSL registered");
		InitializeCriticalSection(&sslHandleMutex);

		return 0;
	}

	FreeLibrary(hSSLLibrary);
	hSSLLibrary=(HINSTANCE)NULL;

	TRACE("Failed to load SSL support");
	return 1;
}


void DeInitSSL()
{
	if(SSLLoaded)
	{

		SSL_CTX_free(SSLCtx);
		if (TLSCtx) 
			SSL_CTX_free(TLSCtx);
		FreeLibrary(hSSLLibrary);
		hSSLLibrary=(HINSTANCE)NULL;
		DeleteCriticalSection(&sslHandleMutex);

		SSLLoaded = FALSE;
		TRACE("SSL unregistered.");
	}
}
#endif //_INCLSSL
